##############################################################################
### ZPyGreSQLDA (c) 2000 by Hagen Fuerstenau and Thomas Viehmann           ###
### see http://www.gurus.de/postgresql/ for details.                       ###
### This is adapted from Digital Creations DA for Oracle                   ###
##############################################################################
# 
# Zope Public License (ZPL) Version 1.0
# -------------------------------------
# 
# Copyright (c) Digital Creations.  All rights reserved.
# 
# This license has been certified as Open Source(tm).
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions in source code must retain the above copyright
#    notice, this list of conditions, and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions, and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. Digital Creations requests that attribution be given to Zope
#    in any manner possible. Zope includes a "Powered by Zope"
#    button that is installed by default. While it is not a license
#    violation to remove this button, it is requested that the
#    attribution remain. A significant investment has been put
#    into Zope, and this effort will continue if the Zope community
#    continues to grow. This is one way to assure that growth.
# 
# 4. All advertising materials and documentation mentioning
#    features derived from or use of this software must display
#    the following acknowledgement:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    In the event that the product being advertised includes an
#    intact Zope distribution (with copyright and license included)
#    then this clause is waived.
# 
# 5. Names associated with Zope or Digital Creations must not be used to
#    endorse or promote products derived from this software without
#    prior written permission from Digital Creations.
# 
# 6. Modified redistributions of any form whatsoever must retain
#    the following acknowledgment:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    Intact (re-)distributions of any official Zope release do not
#    require an external acknowledgement.
# 
# 7. Modifications are encouraged but must be packaged separately as
#    patches to official Zope releases.  Distributions that do not
#    clearly separate the patches from the original work must be clearly
#    labeled as unofficial distributions.  Modifications which do not
#    carry the name Zope may be packaged in any form, as long as they
#    conform to all of the clauses above.
# 
# 
# Disclaimer
# 
#   THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# 
# 
# This software consists of contributions made by Digital Creations and
# many individuals on behalf of Digital Creations.  Specific
# attributions are listed in the accompanying credits file.
# 
##############################################################################

'''$Id: db.py,v 0.1 2000/05/22 15:41:31 hftv Exp $'''
__version__='$Revision: 0.1 $'[11:-2]

import pgdb, DateTime
# ??? DCOracle.dbi.dbiDate=DateTime.DateTime
from Shared.DC.ZRDB.TM import TM # evtl THUNKED_TM

import string, sys, string, time

failures=0
calls=0
last_call_time=time.time()

class DB(TM):

#    _p_oid=_p_changed=_registered=None

    def Database_Connection (self, connection):
        return pgdb.connect (database=connection) #params ???
    Database_Error=pgdb.Error ### ????

    def __init__(self,connection = ''):
        self.connection=connection
        db=self.db=self.Database_Connection(connection)
        self.cursor=db.cursor()
        
    def str(self,v, StringType=type('')):
        if v is None: return ''
        r=str(v)
        if r[-1:]=='L' and type(v) is not StringType: r=r[:-1] # not in python1.6
        return r

    def _finish(self, *ignored):
        self.db.commit()

    def _abort(self, *ignored):
        self.db.rollback()

    # this maps pgsql-classtypes to the dc-types
    __hftv_classtypetranslation = {'r:f':'TABLE', 'r:t':'VIEW'}

    def tables(self, rdb=0,
               _care=('TABLE', 'VIEW')):
        result = []
        if self.cursor._pgdbCursor__source.pgcnx.error: # better way?
          self.cursor.execute ("END;")
        self.cursor.execute ("select relname, relkind, relhasrules"+
                    " from pg_class where relname NOT LIKE 'pg_%';") # or do we need own cursor?

        for [relname, relkind, relrules] in self.cursor.fetchall():
          classtype = relkind+':'+"ft"[relrules]
     
          if (self.__hftv_classtypetranslation.has_key (classtype) and
              self.__hftv_classtypetranslation[classtype] in _care):
            result.append ({'TABLE_NAME': relname, 
                            'TABLE_TYPE': 
                                self.__hftv_classtypetranslation[classtype]})
        open ("/tmp/xxx.txt","a").write ("tables:result "+str (result)+"\n")
        return result

    def columns(self, table_name):
        try: r=self.cursor.execute('select * from %s' % table_name)
        except: return ()
        desc=self.cursor.description
        open ("/tmp/xxx.txt","a").write ("cursor.description"+repr(self.cursor.description)+"\n")
        result=[]
        for name, type, width, ds, p, scale, null_ok in desc:
            if type=='NUMBER' and scale==0: type='INTEGER'
            result.append({ 'Name': name,
                'Type': type,
                'Precision': p,
                'Scale': scale,
                'Nullable': null_ok,
                })

        open ("/tmp/xxx.txt","a").write ("columns:result "+str (result)+"\n")
        return result

    def query(self,query_string, max_rows=9999999):
        global failures, calls, last_call_time
        calls=calls+1
        desc=None
        result=()
        self._register() ###???
        c=self.cursor
        try:
            for qs in filter(None, map(string.strip,string.split(query_string, '\0'))):
	        open ("/tmp/xxx.txt","a").write ("query:executing "+str (qs)+"\n")
                r=c.execute(qs)
	        open ("/tmp/xxx.txt","a").write ("query:r "+str (r)+"\n")
                if r is None:
                    if desc is not None:
                        if c.description != desc:
                            raise 'Query Error', (
                                'Multiple select schema are not allowed'
                                )
                        if type(result) is not ListType: result=list(result)
                        if max_rows:
                            for row in c.fetchmany(max_rows-len(result)):
                                result.append(row)
                    else:
                        desc=c.description
               	        open ("/tmp/xxx.txt","a").write ("query:desc "+str (desc)+"\n")
                        if desc!=None:
                          if max_rows:
                            if max_rows==1: result=(c.fetchone(),)
                            else: result=c.fetchmany(max_rows)
                                
            failures=0
            last_call_time=time.time()
        except self.Database_Error, mess:
            failures=failures+1
            if (failures > 1000 or time.time()-last_call_time > 600):
                # Hm. maybe the db is hosed.  Let's try once to restart it.
                failures=0
                last_call_time=time.time()
		c.close()
		self.db.close()
		db=self.db=self.Database_Connection(self.connection)
		self.cursor=db.cursor()
                return self.query(query_string, max_rows)
	    else: raise sys.exc_type, sys.exc_value, sys.exc_traceback


        if desc is None: return (),()
        open ("/tmp/xxx.txt","a").write ("query:desc "+str (desc)+"\n")

        items=[]
        for name, type, width, ds, p, scale, null_ok in desc:
            if type=='NUMBER':
                if scale==0: type='i'
                else: type='n'
            elif type=='DATE':
                type='d'
            else: type='s'
            items.append({
                'name': name,
                'type': type,
                'width': width,
                'null': null_ok,
                })
        return items, result


